//Uber Tracker
//main_V01_8
//Hopefully the last board...
//making buffers bigger
//a few other tweaks
//Enabling WAAS

//9/20/07, addapting this version for our "generic" version that we'll sell on the website
//12/18/07, this is the "generic" production code

/* *********************************************************
               Function declarations
  ********************************************************* */

#define IAP_LOCATION  0x7FFFFFF1

void Initialize(void);
void feed(void);

void setup_uart0(int baud, char want_ints);
void setup_uart1(int baud, char want_ints);

void config_menu(void);
void get_GPS_2(void);
void get_temp(void);
void set_time(void);
void cell_shutdown(void);
void GPRS_init(char test);
void save_settings(void);
void test_code(void);
void get_remote_address_n_email(void);
void run_sys_2(void);

char getc(void);

void stat0_on (void);
void stat0_off (void);
void stat1_on (void);
void stat1_off (void);

void put_char(char);
void putc2(char);
char getc2(void);



//void T0isr(void)	__irq;
void IRQ_Routine (void)   __attribute__ ((interrupt("IRQ")));
void FIQ_Routine (void)   __attribute__ ((interrupt("FIQ")));
void SWI_Routine (void)   __attribute__ ((interrupt("SWI")));
void UNDEF_Routine (void) __attribute__ ((interrupt("UNDEF")));

static void UART0ISR(void) __attribute__ ((interrupt ("IRQ")));

/**********************************************************
                  Header files
 **********************************************************/
#include "LPC21xx.h"



/**********************************************************
                  Global Variables
 **********************************************************/
char id[15];

char port = 0;          //port 0-1 indicator for the function "put_char"

char RX_array[128];     //UART buffer
static char GPS_short[60];     //short array for a single GPS log, 2 bytes bigger for main_V1_6
char GPS_log[240][60];    //large array to hold all of the GPS logs
static int GPS_stored = 230, GPS_sent = 230;    //indeces for the large GPS array
static int logs = 3;   //number of GPS locks per dump, default = 6
static int logs2 = 3;
unsigned int ram_buff[64];
int yr, mn, dy;
static int interval = 10;   //this is the alarm interval in minutes, default = 10
static int retries = 59;    //this is the number of retries for cell network check and email sending, default = 20
short RX_in = 0, RX_out = 0;
static float battery;
static  float temperature;
static char test2 = 0;
static char power_up = 0;
static int lock_fail = 0;
static int GPRS_fail = 0;
static char remote_address[64];
static int remote_port = 0;
static int mode = 1;
static char email_address[32];
char time[6];
char date[6];
float lat[240];
float lon[240];
static int lat_lon_stored = 230, lat_lon_sent = 230;


#define FLASH_INTERVAL           (*((volatile unsigned long *) 0x0007C000))
#define FLASH_LOGS               (*((volatile unsigned long *) 0x0007C004))
#define FLASH_LOCK_FAIL          (*((volatile unsigned long *) 0x0007C008))
#define FLASH_GPRS_FAIL          (*((volatile unsigned long *) 0x0007C00C))

#define FLASH_REMOTE_ADDRESS_1   (*((volatile unsigned long *) 0x0007C010))//destination address starts at 0x0007C010, goes for 64 bytes
#define FLASH_REMOTE_ADDRESS_2   (*((volatile unsigned long *) 0x0007C014))
#define FLASH_REMOTE_ADDRESS_3   (*((volatile unsigned long *) 0x0007C018))
#define FLASH_REMOTE_ADDRESS_4   (*((volatile unsigned long *) 0x0007C01C))
#define FLASH_REMOTE_ADDRESS_5   (*((volatile unsigned long *) 0x0007C020))
#define FLASH_REMOTE_ADDRESS_6   (*((volatile unsigned long *) 0x0007C024))
#define FLASH_REMOTE_ADDRESS_7   (*((volatile unsigned long *) 0x0007C028))
#define FLASH_REMOTE_ADDRESS_8   (*((volatile unsigned long *) 0x0007C02C))
#define FLASH_REMOTE_ADDRESS_9   (*((volatile unsigned long *) 0x0007C030))
#define FLASH_REMOTE_ADDRESS_10  (*((volatile unsigned long *) 0x0007C034))
#define FLASH_REMOTE_ADDRESS_11  (*((volatile unsigned long *) 0x0007C038))
#define FLASH_REMOTE_ADDRESS_12  (*((volatile unsigned long *) 0x0007C03C))
#define FLASH_REMOTE_ADDRESS_13  (*((volatile unsigned long *) 0x0007C040))
#define FLASH_REMOTE_ADDRESS_14  (*((volatile unsigned long *) 0x0007C044))
#define FLASH_REMOTE_ADDRESS_15  (*((volatile unsigned long *) 0x0007C048))
#define FLASH_REMOTE_ADDRESS_16  (*((volatile unsigned long *) 0x0007C04C))

#define FLASH_PORT               (*((volatile unsigned long *) 0x0007C050))//port number starts at 0x0007C090, 4 bytes

#define FLASH_MODE               (*((volatile unsigned long *) 0x0007C054))//

#define FLASH_EMAIL_ADDRESS_1    (*((volatile unsigned long *) 0x0007C058))//email address starts at 0x0007C058, goes for 32 bytes
#define FLASH_EMAIL_ADDRESS_2    (*((volatile unsigned long *) 0x0007C05C))
#define FLASH_EMAIL_ADDRESS_3    (*((volatile unsigned long *) 0x0007C060))
#define FLASH_EMAIL_ADDRESS_4    (*((volatile unsigned long *) 0x0007C064))
#define FLASH_EMAIL_ADDRESS_5    (*((volatile unsigned long *) 0x0007C068))
#define FLASH_EMAIL_ADDRESS_6    (*((volatile unsigned long *) 0x0007C06C))
#define FLASH_EMAIL_ADDRESS_7    (*((volatile unsigned long *) 0x0007C070))
#define FLASH_EMAIL_ADDRESS_8    (*((volatile unsigned long *) 0x0007C074))

#define FLASH_WRITE_CHECK      (*((volatile unsigned long *) 0x0007C0FC))

unsigned long command[5];
unsigned long result[2];

typedef void (*IAP)(unsigned long[],unsigned long[]);

IAP iap_entry;

/**********************************************************
                       MAIN
**********************************************************/
void __putchar(int ch)
{
  if (ch == '\n')
    put_char('\r');
  put_char(ch);
}

int	main (void)
{	
    int	j, k;

    int i;
    char q, f = 0;
    char temp;

    char h=0, m1=0, m2 = 0, s=0;
    char a, b, c;
    
    Initialize();

    for (j = 0; j < 5; j++)
    {
        stat0_on();
        for (k = 0; k < 120000; k++);
        stat0_off();
        stat1_on();
        for (k = 0; k < 120000; k++);
        stat1_off();
    }


    for (j = 0; j < 64; j++)
    {
        ram_buff[j] = 0;
    }
    
    setup_uart0(38400,1);
    
    setup_uart1(4800,0);

    //ram_buff[0] = FLASH_INTERVAL;
    //ram_buff[1] = FLASH_LOGS;
    //ram_buff[2] = FLASH_LOCK_FAIL;
    //ram_buff[3] = FLASH_GPRS_FAIL;

    //interval = ram_buff[0];
    //logs = ram_buff[1];

    stat0_on();

    //if ((ram_buff[0] & 0xFF000000) == 0xFF000000)   //if it hasn't been written to yet
    if (FLASH_WRITE_CHECK != 0)   //if it hasn't been written to yet
    {
        //This will TX 3 GPS fixes every 30 minutes
        ram_buff[0] = 0x0000000A;    //10 minute reports
        ram_buff[1] = 0x00000003;        //Logs = 3
        ram_buff[2] = 0;
        ram_buff[3] = 0;
        
        //set remote address to "BLANK"
        ram_buff[4] = 0x424C414E;
        ram_buff[5] = 0x4B000000;

        ram_buff[20] = 0;  //remote port = 0
        ram_buff[21] = 1;  //mode = 1, email, Google Maps links

        //set email address to "BLANK"
        ram_buff[22] = 0x424C414E;
        ram_buff[23] = 0x4B000000;
        
        save_settings();

        stat1_on();
        
    }

    

    interval = FLASH_INTERVAL;
    logs = FLASH_LOGS;
    lock_fail = FLASH_LOCK_FAIL;
    GPRS_fail = FLASH_GPRS_FAIL;
    remote_port = FLASH_PORT;
    mode = FLASH_MODE;

    get_remote_address_n_email();

    printf("\r\ninterval = %d\r\n", interval);
    printf("logs = %d\r\n", logs);
    //printf("lock_fail = %d\r\n", lock_fail);
    printf("GPRS_fail = %d\r\n", GPRS_fail);
    printf("Mode = %d\r\n", mode);
    printf("Remote Address = ",0);

    for (j = 0; remote_address[j] != 0; j++)
    {
        put_char(remote_address[j]);
    }

    printf("\r\n",0);
    printf("Remote Port = %d\r\n",remote_port);

    printf("Email Address = ",0);

    for (j = 0; email_address[j] != 0; j++)
    {
        put_char(email_address[j]);
    }

    printf("\r\n",0);

    power_up = 1;

    set_time();

    stat0_off();
    stat1_off();

    temp = SEC + 5;
    if (temp >= 60) temp -= 60;

    U0FCR = 2;  //reset the RX fifo, just in case something weird is sitting there
    RX_in = 0;

    while ((temp != SEC) & (RX_array[RX_in-1] != 32))
    {
        if ((IOPIN0 & 0x00200000) != 0x00200000) test_code();
    }
    
    //feed the watch dog timer
    WDFEED = 0xAA;
    WDFEED = 0x55;

    if ((RX_in > 0) & (RX_array[RX_in-1] == 32)) config_menu(); //only go to the config menu if the space bar has been pressed

    run_sys_2();//endless loop

    while(1);

        	
}



/**********************************************************
                      Initialize
**********************************************************/

#define PLOCK 0x400

void Initialize(void)
{
    // Setting Multiplier and Divider values
    PLLCFG=0x23;
    feed();

    // Enabling the PLL */	
    PLLCON=0x1;
    feed();

    // Wait for the PLL to lock to set frequency
    while(!(PLLSTAT & PLOCK)) ;

    // Connect the PLL as the clock source
    PLLCON=0x3;
    feed();

    // Enabling MAM and setting number of clocks used for Flash memory fetch (4 cclks in this case)
    MAMCR=0x2;
    MAMTIM=0x4;

    // Setting peripheral Clock (pclk) to System Clock (cclk)
    VPBDIV=0x01;
    
    PINSEL0 = 0x00051505;	// enable uart0, enable uart1, enable SPI0 but with SSEL as IO
    PINSEL1 = 0x14000001;	//AD0.2 and AD0.3 active
    PINSEL2 = 0x00000000;       //make sure the trace pins are GPIO
    
    IODIR0 = 0x02420484;   //P0.25 is control line for lt1528 (cell supply, low active), P0.7 as output
    IODIR1 |= 0x00010000;   //P1.16 is cell_on signal

    IOSET0 = 0x80400004;	//P0.31 is high Z for GPS off
    IOCLR0 = 0x02010000;    //make sure P0.25 is low (cell and other peripheral supply)
    
    VICIntSelect = 0x00002000;			//RTC int

    AMR = 249;		//set alarm to read hours and minutes

    CIIR = 0x00;	//disable counter ints
    
    EXTWAKE = 0x80;
    
    //set up the watch dog timer
    WDTC = 0x1A5DE5A2;  //about 30 seconds
    WDMOD = 3;
    WDFEED = 0xAA;
    WDFEED = 0x55;

}


void feed(void)
{
  PLLFEED=0xAA;
  PLLFEED=0x55;
}






/*  Stubs for various interrupts (may be replaced later)  */
/*  ----------------------------------------------------  */

void IRQ_Routine (void)
{
	while(1);
}

static void
UART0ISR(void)
{
      char temp;
      int j;
      
      RX_array[RX_in] = U0RBR;
      RX_in++;

      if (RX_in >= 128) RX_in = 0;
      
      temp = U0IIR;	//have to read this to clear the int

      /* Update VIC priorities */
      VICVectAddr = 0;
      
}



void FIQ_Routine (void)
{
	char a;
	int x;
        
        ILR = 3;
        
}


void SWI_Routine (void)  {
	while (1) ;	
}


void UNDEF_Routine (void) {
	
	stat0_on();
	while (1) ;	
}

//Sends nate to the Transmit Register
void put_char(char c)
{
    if (port == 0)
    {
        while((U0LSR & 0x20) == 0);
        U0THR = c;
    }
    else if (port == 1)
    {
        while((U1LSR & 0x20) == 0);
        U1THR = c;
    }
}


//specific to UART0
char getc(void)
{
    while((U0LSR & 0x01) == 0);
    return (U0RBR);
}
   
char getc2(void)
{
    while((U1LSR & 0x01) == 0);
    return (U1RBR);
}


void putc2(char c)
{
    while((U1LSR & 0x20) == 0);
    U1THR = c;
}

void stat0_off (void)
{
	IOCLR0 = 0x00020000;

}

void stat0_on (void)
{
	IOSET0 = 0x00020000;
	
}

void stat1_off (void)
{
	IOCLR0 = 0x00000400;

}

void stat1_on (void)
{
	IOSET0 = 0x00000400;

}



void setup_uart0(int baud, char want_ints)
{
	//set up uart0 
	U0LCR 	= 0x83;			// 8 bits, no Parity, 1 Stop bit, DLAB = 1
	
	if (baud == 1200)
	{
		U0DLM   = 0x0C;		  	//
  		U0DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
	
	if (baud == 2400)
	{
		U0DLM   = 0x06;		  	//
  		U0DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
		
	if (baud == 4800)
	{
		U0DLM   = 0x03;		  	//
  		U0DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 9600)
	{
	 	U0DLM   = 0x01;		  	//
  		U0DLL 	= 0x80;        	// 9600 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 19200)
	{
	 	U0DLM   = 0x00;		  	//
  		U0DLL 	= 0xC0;        	// 19200 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 38400)
	{
	 	U0DLM   = 0x00;		  	//
  		U0DLL 	= 0x60;        	// 38400 Baud Rate @ 58982400 VPB Clock
	}

        else if (baud == 57600)
	{
	 	U0DLM   = 0x00;		  	//
  		U0DLL 	= 0x40;        	// 57600 Baud Rate @ 58982400 VPB Clock
	}

        else if (baud == 115200)
	{
	 	U0DLM   = 0x00;		  	//
  		U0DLL 	= 0x20;        	// 115200 Baud Rate @ 58982400 VPB Clock
	}
	                    
  	U0FCR	= 0x01;			// Not sure this is necessary, but the manual sez it is
	U0LCR 	= 0x03;        	// DLAB = 0

        if (want_ints == 1)
	{
            __ARMLIB_enableIRQ();

            VICIntSelect &= ~0x00000040;
            /* Enable UART interrupt */
            VICIntEnable |= 0x00000040;
            /* Use slot 1 for UART0 interrupt */
            VICVectCntl1 = 0x26;
            /* Set the address of ISR for slot 1 */
            VICVectAddr1 = (unsigned int)UART0ISR;

            U0IER = 0x01;					//enable RX data available interupt, DLAB must be 0 to write
		
	}
	
	else if (want_ints == 0)
	{
		VICIntEnClr = 0x00000040;	//disables UART0 interupt
		U0IER = 0x00;			//disable RX data available interupt, DLAB must be 0 to write
	}
	
      
}

void setup_uart1(int baud, char want_ints)
{
	//set up uart1
	U1LCR 	= 0x83;			// 8 bits, no Parity, 1 Stop bit, DLAB = 1
	
	if (baud == 1200)
	{
		U1DLM   = 0x0C;		  	//
  		U1DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
	
	if (baud == 2400)
	{
		U1DLM   = 0x06;		  	//
  		U1DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
	
	if (baud == 4800)
	{
		U1DLM   = 0x03;		  	//
  		U1DLL 	= 0x00;        	// 4800 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 9600)
	{
	 	U1DLM   = 0x01;		  	//
  		U1DLL 	= 0x80;        	// 9600 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 19200)
	{
	 	U1DLM   = 0x00;		  	//
  		U1DLL 	= 0xC0;        	// 19200 Baud Rate @ 58982400 VPB Clock
	}
	
	else if (baud == 38400)
	{
	 	U1DLM   = 0x00;		  	//
  		U1DLL 	= 0x60;        	// 38400 Baud Rate @ 58982400 VPB Clock
	}
	
  	U1FCR	= 0x01;			// Not sure this is necessary, but the manual sez it is
  	
	U1LCR 	= 0x03;        	// DLAB = 0
	
	
	if (want_ints == 1)
	{
		VICIntSelect |= 0x00000080;	//bit 7 is for UART1, sets to FIQ (not IRQ)
		VICIntEnable |= 0x00000080;	//enables UART1 interupt
		U1IER = 0x01;			//enable RX data available interupt, DLAB must be 0 to write
		
	}
	
	else if (want_ints == 0)
	{
		VICIntEnClr = 0x00000080;	//disables UART1 interupt
		U1IER = 0x00;					//disable RX data available interupt, DLAB must be 0 to write
	}
	

}





void get_temp(void)
{
    int temp = 0, bat = 0, j;
    temperature = 0;
	
    //Get temperature========================================================================
    AD0CR = 0x0020FF08;	//P0.30
    AD0CR |= 0x01000000;	//start conversion
    
    while ((temp & 0x80000000) == 0)
    {
            temp = AD0DR;
    }
    
    temp &= 0x0000FFC0;
    temp = temp / 0x00000040;
    
    AD0CR = 0x00000000;
    
    temperature = (temp-158)/3.103; //158 is a correction for the doide on the temp sensor

    IOCLR0 = 0x80000000;    //disable peripherals


    //Get battery voltage ==================================================================
    AD0CR = 0x0020FF04;	
    AD0CR |= 0x01000000;//start conversion
    
    while ((bat & 0x80000000) == 0)
    {
            bat = AD0DR;
    }
    

    bat &= 0x0000FFC0;
    bat = bat / 0x00000040;
    
    AD0CR = 0x00000000;
    
    battery = 2.5*bat*(.003222);


}





void GPRS_init(char test)
{
    int delay = 7500000;  //hardware flow control time out
    int j, j2 = 0, j3 = 0, k = 0, m = 0, mstart, a;
    char temp, temp2;
    char q;

    GPRS_fail += 1;  //this will get decremented at the end if GPRS is successful

    //feed the watch dog timer
    WDFEED = 0xAA;
    WDFEED = 0x55;

    //get_temp();

    for (j = 0; j < 128; j++ )
    {
        RX_array[j] = 0;
    }
    
    RX_in = 0;
    
    IOSET0 = 0x02000000;    //enable SPX29302
    for (j = 0; j < 200000; j++ );
    
    //cell_on pulse
    IOSET1 = 0x00010000;  //set P0.31 high
    for (j = 0; j < 4000000; j++ );
    IOCLR1 = 0x00010000;  //set P0.25 low

    for (j = 0; j < 2000000; j++ );    //give the cell some time to come up

    temp2 = SEC + retries;
    if (test == 1) temp2 = SEC + 10;
    if (temp2 >= 60) temp2 -= 60;
    
    while (1)   //verify communication with GM862================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        printf("AT\r",0);

        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-5] != 10));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O')) break;

        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            test2 = 1;
            return;
        }

        for (j = 0; j < 200000; j++ );

    }
    
    if (test == 1)
    {
        cell_shutdown();
        return;
    }

    RX_in = 0;
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;

    while (1)   //set the band========================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        for (j = 0; j < 200000; j++ );

        printf("AT#BND=3\r",0);

        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-5] != 10));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O')) break;

        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            return;
        }
    }

    
    RX_in = 0;
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;

    while (1)   //unidirectional flow control========================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        for (j = 0; j < 200000; j++ );

        printf("AT&K1\r",0);

        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-5] != 10));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O')) break;

        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            return;
        }
    }

    //for (j = 0; j < 200000; j++ );
    //for (j = 0; j < 200000; j++ );

    //temp = SEC+2;
    //if (temp >= 60) temp -= 60;
    //while(SEC != temp);
    
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;

    //for (j = 0; j < 128; j++ )
    //{
        //RX_array[j] = 0;
    //}
    RX_in = 0;
    

    while (1)   //network check==========================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        printf("AT+CGATT\r",0);

        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-9] != '1'));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O') & (RX_array[RX_in-9] == '1')) break;
        
        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            return;
        }

    }

    RX_in = 0;
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;


    while (1)   //Set time and date========================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        for (j = 0; j < 200000; j++ );
        
        //data must be yy/mm/dd
        printf("AT+CCLK=",0);
        put_char(34);
        put_char(date[4]);
        put_char(date[5]);
        put_char(47);
        put_char(date[2]);
        put_char(date[3]);
        put_char(47);
        put_char(date[0]);
        put_char(date[1]);
        put_char(44);
        put_char(time[0]);
        put_char(time[1]);
        put_char(58);
        put_char(time[2]);
        put_char(time[3]);
        put_char(58);
        put_char(time[4]);
        put_char(time[5]);
        printf("+00",0);
        put_char(34);
        printf("\r",0);

        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-5] != 10));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O')) break;

        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            return;
        }
    }

    
    RX_in = 0;
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;

    
    


    while (1)   //Get the IMEI number for ID========================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        for (j = 0; j < 200000; j++ );

        printf("AT+CGSN\r",0);

        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-24] != 10));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O'))
        {
            for (j = 0; j < 15; j++)
            {
                id[j] = RX_array[RX_in-9-j];
            }

            break;
        }

        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            return;
        }

    }


    RX_in = 0;
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;
    


    while (1)   //AT+CGDCONT=1,"IP","isp.cingular","0.0.0.0",0,0==========================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        for (j = 0; j < 200000; j++ );

        printf("AT+CGDCONT=1,",0);
        put_char(34);
        printf("IP",0);
        put_char(34);
        put_char(44);
        put_char(34);
        printf("isp.cingular",0);
        put_char(34);
        put_char(44);
        put_char(34);
        printf("0.0.0.0",0);
        put_char(34);
        printf(",0,0\r",0);


        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-5] != 10));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O')) break;

        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            return;
        }

    }

    RX_in = 0;
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;

    while (1)   //AT#USERID="isp@cingulargprs.com"==========================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        for (j = 0; j < 200000; j++ );

        printf("AT#USERID=",0);
        put_char(34);
        printf("isp@cingulargprs.com",0);

        put_char(34);
        put_char(13);

        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-5] != 10));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O')) break;

        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            return;
        }

    }

    RX_in = 0;
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;

    while (1)   //AT#PASSW="CINGULAR1"==========================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        for (j = 0; j < 200000; j++ );

        printf("AT#PASSW=",0);
        put_char(34);
        printf("CINGULAR1",0);
        put_char(34);
        put_char(13);

        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-5] != 10));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O')) break;

        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            return;
        }

    }

    RX_in = 0;
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;



    while (1)   //AT#ESMTP="cwmx.com"==========================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        for (j = 0; j < 200000; j++ );

        printf("AT#ESMTP=",0);
        put_char(34);
        printf("cwmx.com",0);//Cingular SMTP server
        put_char(34);
        put_char(13);

        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-5] != 10));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O')) break;

        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            return;
        }

    }

    RX_in = 0;
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;



    while (1)   //AT#EADDR="email_address"==========================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        for (j = 0; j < 200000; j++ );

        printf("AT#EADDR=",0);
        put_char(34);
        
        for (j = 0; email_address[j] != 0; j++)
        {
            put_char(email_address[j]);
        }

        put_char(34);
        put_char(13);

        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-5] != 10));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O')) break;

        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            return;
        }

    }

    RX_in = 0;
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;



    while (1)   //AT#SKTSET=0,remote_port,"remote_address"==========================================================
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        for (j = 0; j < 200000; j++ );

        printf("AT#SKTSET=0,%d",remote_port);
        put_char(44);
        put_char(34);
        
        for (j = 0; remote_address[j] != 0; j++)
        {
            put_char(remote_address[j]);
        }

        
        put_char(34);
        put_char(13);

        temp = SEC;

        while((SEC == temp) & (RX_array[RX_in-5] != 10));

        if ((RX_array[RX_in-3] == 'K') & (RX_array[RX_in-4] == 'O')) break;

        RX_in = 0;

        if (SEC == temp2)
        {
            cell_shutdown();
            return;
        }

    }

    RX_in = 0;
    temp2 = SEC + retries;
    if (temp2 >= 60) temp2 -= 60;

    //Email mode=========================================================================================================================================
    //===================================================================================================================================================
    if (mode > 0)
    {
        j3 = 0;

        while ((GPS_sent != GPS_stored) & (lat_lon_sent != lat_lon_stored))
        {

            //feed the watch dog timer
            WDFEED = 0xAA;
            WDFEED = 0x55;
    
            for (j = 0; j < 200000; j++ );
    
            printf("AT#SEMAIL=",0);//AT#SEMAIL="email_address","IMEI#",0==========================================================
            put_char(34);
            
            for (j = 0; email_address[j] != 0; j++)
            {
                put_char(email_address[j]);
            }
    
            put_char(34);
            put_char(44);
            put_char(34);
            
            for (j = 14; j >= 0; j--)    //Print ID======================================
            {
                put_char(id[j]);
            }
    
            put_char(34);            
            printf(",0\r",0);
    
            temp = SEC + 3;
            if (temp >= 60) temp -= 60;
    
            while((SEC != temp) & (RX_array[RX_in-1] != 62));//wait for 3 seconds, or the ">" indicator
            
            
            if (SEC == temp)
            {
                cell_shutdown();
                return;
            }
    
            RX_in = 0;
    
            j2 = 0;

            //Send log==================================================================================================================
            while ((lat_lon_sent != lat_lon_stored) & (j2 < 6))
            {
                //feed the watch dog timer
                WDFEED = 0xAA;
                WDFEED = 0x55;
                
                if (mode == 1)
                {
                    for (j = 0; j < 22; j++ )
                    {
                        put_char(GPS_log[GPS_sent][j]);
                    }

                    //printf("http://maps.google.com/maps?f=q&hl=en&geocode=&time=&date=&ttype=&q=",0);
                    printf("http://maps.google.com/maps?q=",0);
                    printf("%3.6f",lat[lat_lon_sent]);
                    put_char(44);
                    printf("%3.6f",lon[lat_lon_sent]);
                    //printf("&ie=UTF8&z=16&iwloc=addr&om=1",0);
                }

                else if (mode == 2)
                {
                    for (j = 0; j < 22; j++ )
                    {
                        put_char(GPS_log[GPS_sent][j]);
                    }

                    printf("%3.6f",lat[lat_lon_sent]);
                    put_char(44);
                    printf("%3.6f",lon[lat_lon_sent]);

                }

                else if (mode == 3)
                {
                    for (j = 0; j <= 60; j++)
                    {    
                        if (GPS_log[GPS_sent][j] != 0) put_char(GPS_log[GPS_sent][j]);
                    }
                }

                /*
                for (j = 0; j <= 60; j++)
                {    
                    if (GPS_log[GPS_sent][j] != 0) put_char(GPS_log[GPS_sent][j]);
                }
                */
                
                for (j = 0; j < 150000; j++ );    //Maybe need to slow it down a bit...
        
                lat_lon_sent++;
                GPS_sent++;
                j2++;
                if (lat_lon_sent >= 240) lat_lon_sent = 0;
                if (GPS_sent >= 240) GPS_sent = 0;
            }

            put_char(26); //<ctrl>Z
    
            RX_in = 0;
            
            temp = SEC + 59;//Wait 59 seconds for "OK"
            if (temp >= 60) temp -= 60;
    
            while((SEC != temp) & (RX_array[RX_in-5] != 10))
            {
                //feed the watch dog timer
                WDFEED = 0xAA;
                WDFEED = 0x55;
                for (j = 0; j < 1000000; j++ );
            }
            
    
            if ((RX_array[RX_in-3] != 'K') | (SEC == temp))//if it fails...
            {
                
                lat_lon_sent -= j2;//reset the number of last sent log
                GPS_sent -= j2;
                if (lat_lon_sent <= 0) lat_lon_sent += 240;
                if (GPS_sent <= 0) GPS_sent += 240;
                j3++;
                
            }
            else j3 = 0;

            if ((j3 >= 10) | (SEC == temp))
            {
                cell_shutdown();
                return;
            }

        }
                
    }
    //end email mode=====================================================================================================================================
    //===================================================================================================================================================



    //GPRS mode==========================================================================================================================================
    //===================================================================================================================================================
    else if (mode == 0)
    {
        
        //AT#SKTOP"================================================================================
        for (j = 0; j < 200000; j++ );
    
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;
    
        printf("AT#SKTOP\r",0);
    
        temp2 = SEC + 10;
        if (temp2 >= 60) temp2 -= 60;
    
        while((SEC != temp2) & (RX_array[RX_in-10] != 10));  //only wait ten seconds
    
        //if no "CONNECT", shut down and bail out
        if ((RX_array[RX_in-3] != 'T') & (RX_array[RX_in-4] != 'C'))  
        {
            cell_shutdown();
            return;
        }
        
        temp2 = 0;
    
        RX_in = 0;
        j2 = 0;
    
        //If we get here, we're connected =================================================================
    
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;
    
        while (((IOPIN1 & 0x00100000) == 0x00100000) & (j2 < delay))
        {
            j2++;
        }
        j2 = 0;
    
        put_char('$');
    
        while (((IOPIN1 & 0x00100000) == 0x00100000) & (j2 < delay))
        {
            j2++;
        }
        j2 = 0;
    
        put_char('I');
    
        while (((IOPIN1 & 0x00100000) == 0x00100000) & (j2 < delay))
        {
            j2++;
        }
    
        if (j2 == delay)
        {
            cell_shutdown();
            return;
        }
    
        else j2 = 0;
    
        put_char('D');
        
    
        for (j = 14; j >= 0; j--)    //Print ID======================================
        {
            while (((IOPIN1 & 0x00100000) == 0x00100000) & (j2 < delay))
            {
                j2++;
            }
            
            if (j2 == delay)
            {
                cell_shutdown();
                return;
            }
    
            else j2 = 0;
            
            put_char(id[j]);
        }
        
        while (((IOPIN1 & 0x00100000) == 0x00100000) & (j2 < delay))
        {
            j2++;
        }
        j2 = 0;
    
        put_char(10);
    
        while (((IOPIN1 & 0x00100000) == 0x00100000) & (j2 < delay))
        {
            j2++;
        }
    
        if (j2 == delay)
        {
            cell_shutdown();
            return;
        }
    
        else j2 = 0;
    
        put_char(13);
        
        
        //Send log=============================================================================
        while (GPS_sent != GPS_stored)
        {
            //feed the watch dog timer
            WDFEED = 0xAA;
            WDFEED = 0x55;
    
            for (j = 0; j <= 60; j++)
            {
                while (((IOPIN1 & 0x00100000) == 0x00100000) & (j2 < delay))
                {
                    j2++;
                }
            
                if (j2 == delay)
                {
                    cell_shutdown();
                    return;
                }
                else j2 = 0;
    
                if (GPS_log[GPS_sent][j] != 0) put_char(GPS_log[GPS_sent][j]);
            }
            
            for (j = 0; j < 150000; j++ );    //Maybe need to slow it down a bit...
    
            GPS_sent++;
            if (GPS_sent >= 240) GPS_sent = 0;
        }    
    
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;

        RX_in = 0;
    
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;
    
    
        //Bail out==================================================================
        while (((IOPIN1 & 0x00100000) == 0x00100000) & (j2 < delay))
        {
            j2++;
        }
        j2 = 0;
    
        put_char('+');
    
        while (((IOPIN1 & 0x00100000) == 0x00100000) & (j2 < delay))
        {
            j2++;
        }
        j2 = 0;
    
        put_char('+');
    
        while (((IOPIN1 & 0x00100000) == 0x00100000) & (j2 < delay))
        {
            j2++;
        }
    
        if (j2 == delay)
        {
            cell_shutdown();
            return;
        }
    
        put_char('+');
    
        for (j = 0; j < 2000000; j++ );
    
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;
        
        
        
    }
    //=================================================================================================================================================
    //End GPRS mode====================================================================================================================================

    GPRS_fail -= 1;

    cell_shutdown();

    for (j = 0; j < 3; j++)
    {
        stat1_on();
        for (j = 0; j < 1000000; j++ );
        stat1_off();
        for (j = 0; j < 1000000; j++ );
    }    
    
}


//The actual time doesn't matter.  Log time will be reported in the NMEA sentence to the server
void set_time(void)
{
    ALHOUR = 0;         //zero the alarm registers
    ALMIN = 0;

    CCR = 0;
    CCR = 16;		//Enable RTC config

    HOUR = 0;
    MIN = 0;
    SEC = 0;
    
    YEAR = 2000;
    MONTH = 1;
    DOM = 1;

    CCR = 17;		//Run RTC
}




void cell_shutdown(void)
{
    int j;
    signed int k;

    //shut off the cell
    IOSET1 = 0x00010000;  //set P1.16 high
    for (j = 0; j < 4000000; j++ );
    IOCLR1 = 0x00010000;  //set P1.16 low

    for (j = 0; j < 20000000; j++ );
    IOCLR0 = 0x02000000;    //disable SPX29302

}





void save_settings(void)
{
    int j;

    iap_entry = (IAP)IAP_LOCATION;
    
    //Erase first ============================================================================================
    //prep...
    command[0] = 50;
    command[1] = 0x1A;
    command[2] = 0x1A;
    command[3] = 13;
    command[4] = 10;

    iap_entry(command, result);

    for (j = 0; j < 200000; j++ );

    //erase...
    command[0] = 52;
    command[1] = 0x1A;
    command[2] = 0x1A;
    command[3] = 58982;
    command[4] = 0;
    
    iap_entry(command, result);

    for (j = 0; j < 200000; j++ );

    //Then Write ============================================================================================
    //prep...
    command[0] = 50;
    command[1] = 0x1A;
    command[2] = 0x1A;
    command[3] = 13;
    command[4] = 10;

    iap_entry(command, result);

    for (j = 0; j < 200000; j++ );
    
    //write...
    command[0] = 51;
    command[1] = 0x0007C000;
    //command[2] = 0x40007E80;
    command[2] = (int)ram_buff;
    command[3] = 256;
    command[4] = 58982;
    
    iap_entry(command, result);

    for (j = 0; j < 2000000; j++ );


}


void config_menu(void)
{
    char a, b, c, d, e;
    char temp_buff[64];
    int j, k;

    WDTC = 0xFFFFFFFF;    //almost 5 minutes

    //feed the watch dog timer
    WDFEED = 0xAA;
    WDFEED = 0x55;

    setup_uart0(38400,0); //no ints on the uart for now

    //printf("\r\n\nUber Tracker Config Menu, 4/25/07, WAAS enabled, firmware version 1.0\r\n",0);
    //printf("================================================\r\n",0);

    while(1)
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;
        
        printf("\r\n\n",0);
        printf("Uber Tracker, Firmware Version 1.0, 11/29/07, WAAS enabled\r\n",0);
        printf("===================================================================\r\n",0);
        printf("1) Change GPS lock interval, currently %d",interval);
        printf(" minutes\r\n",0);
        printf("2) Change number of logs per Email/GPRS report, currently %d\r\n", logs);
        printf("3) Reset failure log\r\n",0);
        printf("4) Change remote server address, currently ",0);
        for (j = 0; remote_address[j] != 0; j++)
        {
            put_char(remote_address[j]);
        }
        printf("\r\n",0);
        printf("5) Change remote server port, currently %d\r\n",remote_port);
        printf("6) Change mode, currently ",0);
        if (mode == 0) printf("GPRS\r\n",0);
        if (mode == 1) printf("email, Google Maps links\r\n",0);
        if (mode == 2) printf("email, text log\r\n",0);
        if (mode == 3) printf("email, NMEA data\r\n",0);
        printf("7) Change email address, currently ",0);
        for (j = 0; email_address[j] != 0; j++)
        {
            put_char(email_address[j]);
        }
        printf("\r\n",0);

        printf("9) Save and exit\r\n",0);
        
        a = getc();
        
        /*
        if (a == '1')
        {
            printf("\r\nEnter new interval in 4-digit format (i.e., 30 minutes = 0030):",0);
            b = getc();
            put_char(b);
            c = getc();
            put_char(b);
            d = getc();
            put_char(d);
            e = getc();
            put_char(e);

            printf("\r\n",0);

            interval = (b-48)*1000 + (c-48)*100 + (d-48)*10 + (e-48);
        }
        */


        if (a == '1')
        {
            k = 0;
            for (j = 0; j < 64; j++)
            {
                temp_buff[j] = 0;
            }

            printf("\r\nEnter your new GPS interval (in decimal, not hex), followed by enter/return.\r\n",0);

            for(j = 0; j < 6; j++)
            {
                b = getc();
                if ((b == 10) | (b == 13))
                {
                    k += temp_buff[j-1]-48;
                    if (j-2 >= 0) k += (temp_buff[j-2]-48)*10;
                    if (j-3 >= 0) k += (temp_buff[j-3]-48)*100;
                    if (j-4 >= 0) k += (temp_buff[j-4]-48)*1000;
                    if (j-5 >= 0) k += (temp_buff[j-5]-48)*10000;

                    break;
                
                }
                else if ((b > 47) & (b < 58)) 
                {
                    temp_buff[j] = b;
                    put_char(b);
                }

                //feed the watch dog timer
                WDFEED = 0xAA;
                WDFEED = 0x55;
            }
            
            interval = k;
        }


        
        else if (a == '2')
        {
            b = 0;

            printf("\r\nEnter number of logs per report (from 1 to 6):",0);

            while ((b < 49) | (b > 54))
            {
                b = getc();
            }
            put_char(b);

            printf("\r\n",0);
            
            logs = b-48;

        }

        //reset email/GPRS fail log===============================================================================
        else if (a == '3')
        {
            printf("\r\nThis number is used for diagnosis of potentially faulty units.\r\n",0);
            printf("The only time it should be reset is after service has been performed.\r\n",0);
            printf("Are you absolutely sure you want to do this?  Hit 'y' if you wish to continue,\r\n",0);
            printf("or anything else if you wish to abort.\r\n",0);

            b = getc();

            if ((b == 'y') | (b == 'Y'))
            {
                lock_fail = 0;
                GPRS_fail = 0;
                printf("\r\n\r\nGPRS_fail has been reset to 0.\r\n\r\n",0);
            }

            else printf("\r\nAborted.\r\n\r\n",0);
            
        }
        
        //change remote address=======================================================================================
        else if (a == '4')
        {
            for (j = 4; j < 20; j++)
            {
                ram_buff[j] = 0;
            }

            for (j = 0; j < 64; j++)
            {
                temp_buff[j] = 0;
            }

            printf("\r\nEnter your new remote address, followed by enter/return.\r\n",0);

            for (j = 0; j < 64; j++)
            {
                b = getc();
                if ((b == 10) | (b == 13)) break;
                else temp_buff[j] = b;
                put_char(b);

                //feed the watch dog timer
                WDFEED = 0xAA;
                WDFEED = 0x55;
            }
            
            printf("\r\n",0);

            for(j = 0; j < 16; j++)
            {
                ram_buff[j+4] = (int)((temp_buff[4*j]) << 24) + (int)((temp_buff[4*j+1]) << 16) + (int)((temp_buff[4*j+2]) << 8) + (int)(temp_buff[4*j+3]);
                
            }

            for(j = 0; j < 64; j++)
            {
                remote_address[j] = temp_buff[j];

            }
        }
        

        //change remote port=========================================================================================
        else if (a == '5')
        {
            k = 0;
            for (j = 0; j < 64; j++)
            {
                temp_buff[j] = 0;
            }

            printf("\r\nEnter your new remote port (in decimal, not hex), followed by enter/return.\r\n",0);

            for(j = 0; j < 6; j++)
            {
                b = getc();
                if ((b == 10) | (b == 13))
                {
                    k += temp_buff[j-1]-48;
                    if (j-2 >= 0) k += (temp_buff[j-2]-48)*10;
                    if (j-3 >= 0) k += (temp_buff[j-3]-48)*100;
                    if (j-4 >= 0) k += (temp_buff[j-4]-48)*1000;
                    if (j-5 >= 0) k += (temp_buff[j-5]-48)*10000;

                    break;
                
                }
                else if ((b > 47) & (b < 58)) 
                {
                    temp_buff[j] = b;
                    put_char(b);
                }

                //feed the watch dog timer
                WDFEED = 0xAA;
                WDFEED = 0x55;
            }
            
            remote_port = k;
        }
 


        //change mode=============================================================================================
        else if (a == '6')
        {
            mode++;
            if (mode == 4) mode = 0;
        }



        //change email address=======================================================================================
        else if (a == '7')
        {
            for (j = 22; j < 29; j++)
            {
                ram_buff[j] = 0;
            }

            for (j = 0; j < 64; j++)
            {
                temp_buff[j] = 0;
            }

            printf("\r\nEnter your new email address, followed by enter/return.\r\n",0);

            for (j = 0; j < 32; j++)
            {
                b = getc();
                if ((b == 10) | (b == 13)) break;
                else temp_buff[j] = b;
                put_char(b);

                //feed the watch dog timer
                WDFEED = 0xAA;
                WDFEED = 0x55;
            }
            
            printf("\r\n",0);

            for(j = 0; j < 8; j++)
            {
                ram_buff[j+22] = (int)((temp_buff[4*j]) << 24) + (int)((temp_buff[4*j+1]) << 16) + (int)((temp_buff[4*j+2]) << 8) + (int)(temp_buff[4*j+3]);
                
            }

            for(j = 0; j < 32; j++)
            {
                email_address[j] = temp_buff[j];

            }
        }



        //save and exit===========================================================================================
        else if (a == '9')
        {
            if ((interval > 1440) | (interval < 1))
            {
                printf("\r\nInterval out of range.  Setting to 5 minutes.\r\n",0);
                interval = 5;
            }

            if ((logs > 6) | (logs < 1))
            {
                printf("\r\nLogs out of range.  Setting to 1 log per GPRS report.\r\n",0);
                logs = 1;
            }

            if (remote_port > 65535)
            {
                printf("\r\nRemote Port out of range.  Setting to 0.\r\n",0);
                remote_port = 0;
            }

            ram_buff[0] = interval;
            ram_buff[1] = logs;
            ram_buff[2] = lock_fail;
            ram_buff[3] = GPRS_fail;
            ram_buff[20] = remote_port;
            ram_buff[21] = mode;
            save_settings();

            printf("\r\nSettings saved.  Disconnect your serial cable and reset your unit to talk\r\n",0);
            printf("to the cell module.  Then cycle power on the tracker.",0);

            while(1)
            {
                //feed the watch dog timer
                WDFEED = 0xAA;
                WDFEED = 0x55;;
            }
        }
        
    }

}


void test_code(void)
{
    int a;
    char temp, j = 0, k;

    //feed the watch dog timer
    WDFEED = 0xAA;
    WDFEED = 0x55;
    
    //test RTC
    stat1_on();
    temp = SEC + 2;
    if (temp >= 60) temp -= 60;
    while (SEC != temp);
    stat1_off();

    get_temp();

    if ((battery < 6.95) | (battery > 7.55)) j += 1;
    if ((temperature < 60) | ( temperature > 90)) j += 2;

    temp = SEC + 5;
    if (temp >= 60) temp -= 60;

    //GPS on
    IOCLR0 = 0x80000000;  //set P0.31 low
    IODIR0 |= 0x80000000; //make P0.31 output

    while (SEC != temp)
    {
        if ((U1LSR & 0x01) != 0)	//if something comes in on port1...
        {
            if (U1RBR == '$') break;	//gotta read the RX buffer to set the flag back to 0
              
        }
    }

    //GPS off
    IOSET0 = 0x80000000;  //set P0.31 high
    IODIR0 &= 0x7FFFFFFF; //make P0.31 high Z
    
    if (SEC == temp) j += 4;

    IOSET0 = 0x02000000;    //enable SPX29302

    //feed the watch dog timer
    WDFEED = 0xAA;
    WDFEED = 0x55;

    GPRS_init(1);

    if (test2 == 1) j+= 8;

    if (j > 0)
    {
        while(1)
        {
            
            for (k = 0; k < j; k++)
            {
                stat0_on();
                for (a = 0; a < 700000; a++ );
                stat0_off();
                for (a = 0; a < 700000; a++ );
            }
            

            for (a = 0; a < 1500000; a++ );

            //feed the watch dog timer
            WDFEED = 0xAA;
            WDFEED = 0x55;
        }
    }

    while(1)
    {
        stat1_on();
        for (a = 0; a < 700000; a++ );
        stat1_off();
        for (a = 0; a < 700000; a++ );

        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;
    }

}

void get_remote_address_n_email(void)
{
    int j;
    
    //get remote address
    ram_buff[4] = FLASH_REMOTE_ADDRESS_1;
    ram_buff[5] = FLASH_REMOTE_ADDRESS_2;
    ram_buff[6] = FLASH_REMOTE_ADDRESS_3;
    ram_buff[7] = FLASH_REMOTE_ADDRESS_4;
    ram_buff[8] = FLASH_REMOTE_ADDRESS_5;
    ram_buff[9] = FLASH_REMOTE_ADDRESS_6;
    ram_buff[10] = FLASH_REMOTE_ADDRESS_7;
    ram_buff[11] = FLASH_REMOTE_ADDRESS_8;
    ram_buff[12] = FLASH_REMOTE_ADDRESS_9;
    ram_buff[13] = FLASH_REMOTE_ADDRESS_10;
    ram_buff[14] = FLASH_REMOTE_ADDRESS_11;
    ram_buff[15] = FLASH_REMOTE_ADDRESS_12;
    ram_buff[16] = FLASH_REMOTE_ADDRESS_13;
    ram_buff[17] = FLASH_REMOTE_ADDRESS_14;
    ram_buff[18] = FLASH_REMOTE_ADDRESS_15;
    ram_buff[19] = FLASH_REMOTE_ADDRESS_16;

    for(j = 0; j < 16; j++)
    {
        remote_address[j*4] = (char)(((ram_buff[4+j]) & 0xFF000000) >> 24);
        remote_address[j*4+1] = (char)(((ram_buff[4+j]) & 0x00FF0000) >> 16);
        remote_address[j*4+2] = (char)(((ram_buff[4+j]) & 0x0000FF00) >> 8);
        remote_address[j*4+3] = (char)(((ram_buff[4+j]) & 0x000000FF));
    }

    
    //get email address
    ram_buff[22] = FLASH_EMAIL_ADDRESS_1;
    ram_buff[23] = FLASH_EMAIL_ADDRESS_2;
    ram_buff[24] = FLASH_EMAIL_ADDRESS_3;
    ram_buff[25] = FLASH_EMAIL_ADDRESS_4;
    ram_buff[26] = FLASH_EMAIL_ADDRESS_5;
    ram_buff[27] = FLASH_EMAIL_ADDRESS_6;
    ram_buff[28] = FLASH_EMAIL_ADDRESS_7;
    ram_buff[29] = FLASH_EMAIL_ADDRESS_8;

    for(j = 0; j < 8; j++)
    {
        email_address[j*4] = (char)(((ram_buff[22+j]) & 0xFF000000) >> 24);
        email_address[j*4+1] = (char)(((ram_buff[22+j]) & 0x00FF0000) >> 16);
        email_address[j*4+2] = (char)(((ram_buff[22+j]) & 0x0000FF00) >> 8);
        email_address[j*4+3] = (char)(((ram_buff[22+j]) & 0x000000FF));
    }
}


void run_sys_2(void)
{
    int temp_min, temp_hour, temp_sec;
    int a, b;
    
    while(1)
    {

        for (a = 0; a < logs; a++)
        {
            get_GPS_2();
    
            for (b = 0; b < 60; b++)
            {
                GPS_log[GPS_stored][b] = GPS_short[b];
    
            }
    
            GPS_stored++;
            if (GPS_stored >= 240) GPS_stored = 0;
            if (GPS_stored == GPS_sent) GPS_sent++; //circular...

            if (a == (logs-1))
            {
                GPRS_init(0);
            
                if (GPRS_fail != ram_buff[3])
                {
                    ram_buff[0] = interval; 
                    ram_buff[1] = logs;        
                    ram_buff[3] = GPRS_fail;
                    ram_buff[20] = remote_port;
                    ram_buff[21] = mode;
                    save_settings();

                }
            }

            temp_sec = SEC;
            temp_hour = HOUR;
            temp_min = MIN + interval;
            while (temp_min >= 60)
            {
                temp_min -= 60;
                temp_hour += 1;
            }
            if (temp_hour >= 24) temp_hour -= 24;
    
            while ((MIN != temp_min) | (HOUR != temp_hour) | (SEC != temp_sec))
            {
                //feed the watch dog timer
                WDFEED = 0xAA;
                WDFEED = 0x55;
            }
        }

    }


}



//GPS Parser for continous mode
void get_GPS_2(void)
{
    int x, y;
    char temp, temp2, temp3 = 0;

    if (power_up == 1)
    {
        //GPS on
        IOCLR0 = 0x80000000;  //set P0.31 low
        IODIR0 |= 0x80000000; //make P0.31 output
       
        setup_uart1(4800,0); 
    
        port = 1;
    
        //Enable WAAS
        for (x = 0; x < 5000000; x++);
        printf("$PSRF151,01*0F",0); 
        put_char(13);
        put_char(10);
    
        port = 0;
        //power_up = 0;
    }
    
    stat0_on();

    for (x = 0; x < 59; x++)
    {
        GPS_short[x] = 0;
    }
    GPS_short[0] = 10;
    GPS_short[1] = 13;


    while(1)
    {
        //feed the watch dog timer
        WDFEED = 0xAA;
        WDFEED = 0x55;
        
        temp = 'X';

        if ((U1LSR & 0x01) != 0)	//if something comes in on port1...
        {
            temp = U1RBR;	//gotta read the RX buffer to set the flag back to 0
           
        }

        
        if (temp == '$')
        {
            temp = getc2();
            temp = getc2();
            temp = getc2();

            if (temp == 'R')
            {
                temp = getc2();
                temp = getc2();
                temp = getc2();
                temp = getc2();

                if (temp != ',')
                {
                    GPS_short[2] = temp;
                    temp = 0;

                    for (x = 3; x < 60; x++)
                    {
                        GPS_short[x] = getc2();
                        if (GPS_short[x] == ',') temp++;
                        if (temp == 9)
                        {
                            GPS_short[x] = 0;
                            break;
                        }

                        if (x == 13)
                        {
                            if (GPS_short[x] != 'A') break;

                            //the first lock is usually off, wait a few seconds for it to clear up
                            else if ((GPS_short[x] == 'A') & (power_up == 1))
                            {
                                temp = SEC + 15;
                                if (temp >= 60) temp -= 60;
                                while(temp != SEC);
                                power_up = 0;
                                break;
                            }
                        }

                    }

                    if (x >= 55) break;
                }
            }
        }
    }
  
    for (x = 0; x < 6; x++)//get time
    {
        time[x] = GPS_short[x+2];
    }

    temp = 0;

    for (x = 0; x < 60; x++)//get date
    {
        if (GPS_short[x] == ',') temp++;
        if (temp == 8)
        {
            date[0] = GPS_short[x+1];//day
            date[1] = GPS_short[x+2];//day
            date[2] = GPS_short[x+3];//month
            date[3] = GPS_short[x+4];//month
            date[4] = GPS_short[x+5];//year
            date[5] = GPS_short[x+6];//year
            break;
        }
    }
    
    temp = 0;

    for (x = 0; x < 60; x++)//get latitude
    {
        if (GPS_short[x] == ',') temp++;
        if (temp == 3)
        {
            lat[lat_lon_stored] = (GPS_short[x-1]-48) + (GPS_short[x-2]-48)*10 + (GPS_short[x-3]-48)*100 + (GPS_short[x-4]-48)*1000 + (GPS_short[x-6]-48)*10000 + (GPS_short[x-7] -48)*100000;
            lat[lat_lon_stored] *= .0001;
            lat[lat_lon_stored] *= .0166666666;
            lat[lat_lon_stored] += (GPS_short[x-8] - 48);
            if ((GPS_short[x-9] > 47) & (GPS_short[x-9] < 58)) lat[lat_lon_stored] += (GPS_short[x-9] - 48)*10;
            if (GPS_short[x+1] == 83) lat[lat_lon_stored] *= -1;
            break;
        }
    }

    temp = 0;

    for (x = 0; x < 60; x++)//get longitude
    {
        if (GPS_short[x] == ',') temp++;
        if (temp == 5)
        {
            lon[lat_lon_stored] = (GPS_short[x-1]-48) + (GPS_short[x-2]-48)*10 + (GPS_short[x-3]-48)*100 + (GPS_short[x-4]-48)*1000 + (GPS_short[x-6]-48)*10000 + (GPS_short[x-7] -48)*100000;
            lon[lat_lon_stored] *= .0001;
            lon[lat_lon_stored] *= .0166666666;
            lon[lat_lon_stored] += (GPS_short[x-8] - 48);
            if ((GPS_short[x-9] > 47) & (GPS_short[x-9] < 58)) lon[lat_lon_stored] += (GPS_short[x-9] - 48)*10;
            if ((GPS_short[x-10] > 47) & (GPS_short[x-10] < 58)) lon[lat_lon_stored] += (GPS_short[x-10] - 48)*100;
            if (GPS_short[x+1] == 87) lon[lat_lon_stored] *= -1;
            break;
        }
    }

    if ((mode == 1) | (mode == 2))
    {
        for (x = 0; x < 59; x++)
        {
            GPS_short[x] = 0;
        }
        GPS_short[0] = 10;
        GPS_short[1] = 13;

        GPS_short[2] = date[2];//month
        GPS_short[3] = date[3];//month
        GPS_short[4] = 47;
        GPS_short[5] = date[0];//day
        GPS_short[6] = date[1];//day
        GPS_short[7] = 47;
        GPS_short[8] = date[4];//year
        GPS_short[9] = date[5];//year

        GPS_short[10] = 44;
        GPS_short[11] = 32;

        GPS_short[12] = time[0];//hour
        GPS_short[13] = time[1];//hour
        GPS_short[14] = 58;
        GPS_short[15] = time[2];//minute
        GPS_short[16] = time[3];//minute
        GPS_short[17] = 58;
        GPS_short[18] = time[4];//second
        GPS_short[19] = time[5];//second

        GPS_short[20] = 44;
        GPS_short[21] = 32;
    }

    
    lat_lon_stored++;
    if (lat_lon_stored >= 240) lat_lon_stored = 0;
    stat0_off();

}

